unit Unit1;

{
  DavData Software
  frame rigidity test
  version 1
  28-03-2017
  version 1.1   :  corrected error in procedure testframe
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, shellApi;

type
  TForm1 = class(TForm)
    loadBtn: TSpeedButton;
    storeBtn: TSpeedButton;
    helpbutton: TSpeedButton;
    PaintBox1: TPaintBox;
    msglabel: TLabel;
    Label1: TLabel;
    Image1: TImage;
    clearBtn: TBitBtn;
    editBtn: TSpeedButton;
    testBtn: TSpeedButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    minBtn: TBitBtn;
    minclearBtn: TBitBtn;
    Label2: TLabel;
    procedure FormPaint(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure clearBtnClick(Sender: TObject);
    procedure editBtnClick(Sender: TObject);
    procedure storeBtnClick(Sender: TObject);
    procedure loadBtnClick(Sender: TObject);
    procedure minBtnClick(Sender: TObject);
    procedure minclearBtnClick(Sender: TObject);
    procedure helpbuttonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

type TBox = record
             column : byte;
             row    : byte;
            end;
     TMenuButton = (mbEdit,mbTest);
     TIOpack = array[1..37] of dword;
     TBoxBrace = (bbNone,bbBrace,bbRemoved);

const leftmargin = 40;
      topmargin = 40;
      msg1 = 'alter frame by left/right mouseclicks...click column/row -0-'+
             ' to alter only columns/rows';
      msg2 = 'non rigid frame';
      msg3 = 'rigid frame';
      fileID = 'davdataframework';

var boxX,boxY : byte;  //mouse selected box 0..7   $ff =none
    framewidth : byte; //1..8
    frameheight : byte;//1..8
    boxbrace : array[0..7,0..7] of TBoxBrace;
    coords : array[0..8,0..8] of TPoint; //coordinates of joints
    columnvector : array[0..7] of byte;  //bit 1: row connected
    rowvector : array[0..7] of byte;     //bit 1: column connected
    menubutton : TmenuButton;
    map : TBitmap;     //holds frame
    IOpack : TIOpack;

procedure paintboxedges;
//paint lines on form1 around paintbox1
var x1,y1,x2,y2 : word;
    i : byte;
begin
 with form1 do
  begin
   x1 := paintbox1.Left - 2;
   y1 := paintbox1.Top - 2;
   x2 := paintbox1.Left+paintbox1.Width + 1;
   y2 := paintbox1.Top + paintbox1.Height + 1;
   with canvas do
    begin
     pen.width := 1;
     for i := 0 to 1 do
      begin
       pen.Color := $000000;
       moveto(x2 - i,y1 + i);
       lineto(x1 + i,y1 + i);
       lineto(x1 + i,y2 - i);
       pen.Color := $808080;
       lineto(x2 - i,y2 - i);
       lineto(x2 - i, y1 +i)
      end;
    end;
  end;
end;

function xy2box(x,y : word) : byte;
//return box #  $ff is none
begin
 if (x > leftmargin) and (x < leftmargin + 800) and
    (y > topmargin) and (y < topmargin + 480) then
  begin
   x := (x - leftmargin) div 100;
   y := (y - topmargin) div 60;
   result := x or (y shl 3);
  end
  else result := $ff;
end;

procedure paintframe;
var code,i,j,imax,jmax : byte;
begin
 imax := 7;
 jmax := 7;
 if menubutton = mbTest then
  begin
   imax := framewidth-1;
   jmax := frameheight-1;
  end;
 with  map do with canvas do
  begin
   brush.Color := $ffffff;
   brush.Style := bsSolid;
   fillrect(rect(0,0,width,height));
   for j := 0 to jmax do
    for i := 0 to imax do
     begin
      pen.color := $000000;
      if i > 0 then code := 1 else code := 0;
      if j > 0 then code := code or $2;
      if (framewidth > i) and (frameheight > j) then
       begin
        pen.Color := $000000;
        pen.Width := 3;
       end
       else begin
             pen.Color := $c0c0c0;
             pen.Width := 1;
            end;
      case code of
       0 : begin                                     //left top
            moveto(coords[i,j].x, coords[i,j].y);
            lineto(coords[i+1,j].x, coords[i+1,j].y);
            lineto(coords[i+1,j+1].x, coords[i+1,j+1].y);
            lineto(coords[i,j+1].x, coords[i,j+1].Y);
            lineto(coords[i,j].x, coords[i,j].y);
           end;
       1 : begin                                    //top right
            moveto(coords[i,j].x, coords[i,j].y);
            lineto(coords[i+1,j].x, coords[i+1,j].y);
            lineto(coords[i+1,j+1].x, coords[i+1,j+1].y);
            lineto(coords[i,j+1].x, coords[i,j+1].Y);
           end;
       2 : begin                                    //left
            moveto(coords[i+1,j].x, coords[i+1,j].y);
            lineto(coords[i+1,j+1].x, coords[i+1,j+1].y);
            lineto(coords[i,j+1].x, coords[i,j+1].Y);
            lineto(coords[i,j].x, coords[i,j].y);
           end;
       3 : begin                                   //middle,right
            moveto(coords[i+1,j].x, coords[i+1,j].y);
            lineto(coords[i+1,j+1].x, coords[i+1,j+1].y);
            lineto(coords[i,j+1].x, coords[i,j+1].y);
           end;
      end;//case
      if boxbrace[i,j] <> bbNone then
       begin
        if boxbrace[i,j] = bbRemoved then pen.color := $c0c0c0;
        if i and $1 = 0 then                     //left - right diagonal
         begin
          moveto(coords[i,j+1].x, coords[i,j+1].y);
          lineto(coords[i+1,j].x, coords[i+1,j].y);
         end
         else begin
               moveto(coords[i,j].x, coords[i,j].y);
               lineto(coords[i+1,j+1].x, coords[i+1,j+1].y);
              end;
       end;
     end;//for i,j
  end;//with map
 form1.PaintBox1.Invalidate;
end;

procedure clearBraces;
var i,j : byte;
begin
 boxX := $ff; boxY := $ff;   //none selected
 for j := 0 to 7 do
  for i := 0 to 7 do  boxbrace[i,j] := bbNone;
end;

procedure initCoords;
var i,j : byte;
    x,y : word;
begin
 for j := 0 to 8 do
  begin
   y := topmargin + j*60;
   for i := 0 to 8 do
    begin
     x := leftmargin + i*100;
     coords[i,j].X := x;
     coords[i,j].Y := y;
    end;
  end;
end;

procedure makeConnectionVectors;
//col2rows[0..7]  row2cols[0..7]
var i,j : byte;
begin
 for i := 0 to 7 do
  begin
   columnvector[i] := 0;
   rowvector[i] := 0;
  end;
 for j := 0 to 7 do
  for i := 0 to 7 do
   if boxbrace[i,j] = bbBrace then
    begin
     columnvector[i] := columnvector[i] or (1 shl j);
     rowvector[j] := rowvector[j] or (1 shl i);
    end;
end;

function nextRect(var n : byte; vec : byte) : boolean;
//true if next column/row of vector
//n : lowest bit set in vec
begin
 result := vec <> 0;
 if result  then
  begin
   n := 0;
   while ((1 shl n) and vec) = 0 do inc(n);
  end;
end;

function rigid(xcol,xrow : byte) : boolean;
//return true if box is rigid (no distortion possible)
var stepNr,n,v : byte;
    colEnables : byte;
    rowEnables : byte;
    box : array[1..16] of TBox;
    GO         : boolean;    //false to exit repeat loop
begin
 result := columnvector[xcol] and (1 shl xrow) <> 0;
 if result then exit;

 rowEnables := $ff;            //select all rows
 colEnables := $ff;            //..         columns

//---start rectangle

 stepNr := 1;
 with box[stepnr] do
  begin
   column := xcol;
   row := xrow;
   rowEnables := rowEnables xor (1 shl xrow);
  end;

 GO := true;
 repeat
//                                                      next column
  v := colEnables and rowVector[box[stepNr].row];
  if nextRect(n,v) then
   begin
    if n <> xcol then
     begin
      inc(stepNr);
      box[stepNr].column := n;
      colEnables := colEnables xor (1 shl n);
      n := box[stepNr-1].row;
      box[stepNr].row := n;
     end
     else begin
           result := true;        //true exit
           GO := false;
          end;
   end
   else if stepNr = 1 then
         begin
          result := false;        //false exit
          GO := false;
         end
         else dec(stepNr);
//                                                      next row
  v := rowEnables and columnVector[box[stepNr].column];
  if nextRect(n,v) then
   begin
    inc(stepNr);
    box[stepNr].row := n;
    rowEnables := rowEnables xor (1 shl n);
    n := box[stepNr-1].column;
    box[stepNr].column := n;
   end
   else dec(stepNr);
//
 until GO = false;
end;

procedure TestFrame;
//check / calculate distortion
type Toffset = record
                dx1,dy1 : smallInt;
                dx2,dy2 : smallInt;
                dx3,dy3 : smallInt;
               end;
const topcodesNR : array[0..3] of byte = (2,1,2,1); //top
      topCodesR : array[0..3] of byte = (0,3,0,3);  //top rigid
//====      leftcodesNR : array[0..3] of byte = (1,1,2,2);//left   deleted v1.1
//
      offset  : array[0..3] of TOffset =
                ((dx1:  0; dy1: 60; dx2: 100; dy2:  60; dx3: 100; dy3:  0), //0
                 (dx1:-25; dy1: 54; dx2:  75; dy2:  54; dx3: 100; dy3:  0), //1
                 (dx1:  0; dy1: 60; dx2:  91; dy2: 102; dx3:  91; dy3: 42), //2
                 (dx1:-25; dy1: 54; dx2:  66; dy2:  96; dx3:  91; dy3: 42));//3
var i,j : byte;
    bxt : byte;
    topbox : array[0..7] of byte;
    leftbox : array[0..7] of byte;
    xref,yref,corr : smallInt;
    RFlag,CFlag : boolean;
begin
 bxt := 0;
 makeconnectionvectors;
 RFlag := rigid(0,0);              //top left
 if RFlag = false then bxt := 1 else bxt := 0;
 leftbox[0] := bxt;
 topbox[0] := bxt;
 xref := coords[0,0].X;
 yref := coords[0,0].Y;
 coords[0,1].x := xref + offset[bxt].dx1;
 coords[1,1].X := xref + offset[bxt].dx2;
 coords[0,1].y := yref + offset[bxt].dy1;
 coords[1,1].y := yref + offset[bxt].dy2;
 for i := 1 to framewidth-1 do
  begin                            //top
   xref := coords[i,0].X;
   yref := coords[i,0].y;
   RFlag := rigid(i,0);
   bxt := topbox[i-1];
   if RFlag then bxt := topCodesR[bxt]
    else bxt := topcodesNR[bxt];
   topbox[i] := bxt;
   coords[i+1,1].x := xref + offset[bxt].dx2;
   coords[i+1,1].y := yref + offset[bxt].dy2;
   coords[i+1,0].x := xref + offset[bxt].dx3;
   coords[i+1,0].y := yref + offset[bxt].dy3;
  end;
 for j := 1 to frameheight-1 do
  begin                            //left
   xref := coords[0,j].x;
   yref := coords[0,j].Y;
   CFlag := nextRect(bxt,rowvector[j]);
   if CFlag then
    begin
     bxt := topbox[bxt];
     bxt := ((bxt and $2) shr 1) or (leftbox[0] and $2);
    end
    else bxt := 1;//error======leftCodesNR[bxt]  v1.1;
   leftbox[j] := bxt;
   coords[0,j+1].x := xref + offset[bxt].dx1;
   coords[0,j+1].y := yref + offset[bxt].dy1;
   coords[1,j+1].x := xref + offset[bxt].dx2;
   coords[1,j+1].y := yref + offset[bxt].dy2;
  end;
 for j := 1 to frameheight-1 do    //not top or left
  for i := 1 to framewidth-1 do
   begin
    xref := coords[i,j].x;
    yref := coords[i,j].y;
    bxt := (leftbox[j] and $1) or (topbox[i] and $2);
    coords[i+1,j+1].x := xref + offset[bxt].dx2;
    coords[i+1,j+1].y := yref + offset[bxt].dy2;
   end;
//
corr := leftmargin-coords[0,frameheight].x;
 if corr > 0 then
  for j := 0 to frameheight do
   for i := 0 to framewidth do
    coords[i,j].x := coords[i,j].X + corr; //shift right
//
 bxt := 0;                                //report frame type
 for i := 0 to framewidth-1 do bxt := bxt + topbox[i];
 for j := 1 to frameheight-1 do bxt := bxt + leftbox[j];
 with form1.msglabel do
  if bxt = 0 then caption := msg3
   else caption := msg2;
end;

function rigidframe : boolean;
//return true if total frame is rigid
//test rigidity of top row and left column
var i : byte;
begin
 result := true;
 i := 0;
 while result and (i < framewidth) do
  begin
   result := rigid(i,0);
   inc(i);
  end;
 if result then
  begin
   i := 1;
   while result and (i < frameheight) do
    begin
     result := rigid(0,i);
     inc(i);
    end;
  end;
end;

//----------events-------

procedure TForm1.FormPaint(Sender: TObject);
begin
 paintboxedges;
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
 paintbox1.canvas.draw(0,0,map);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 menubutton := mbEdit;
 editBtn.Down := true;
 map := TBitmap.create;
 with map do
  begin
   width := paintbox1.Width;
   height := paintbox1.Height;
   pixelformat := pf32bit;
  end;
 framewidth := 1;
 frameheight := 1;
 clearBraces;
 initcoords;
 paintframe;
 msglabel.caption := msg1;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 map.Free;
end;

procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var n : byte;
begin
 n := xy2box(x,y);
 if n <> $ff then
  begin
   boxX := n and $7;
   boxY := n shr 3;
  end
  else begin
        boxX := $ff;
        boxY := $ff;
       end;
end;

procedure TForm1.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
//frame editing
var expandflag : boolean;
    code,i,j : byte;
begin
 if menubutton = mbTest then exit;
//
 expandflag := false;            //if edit mode selected
 if button = mbleft then
  begin
   if boxX <> $ff then
    begin
     if boxX >= framewidth then
      begin
       framewidth := boxX + 1;
       expandflag := true;
      end;
     if boxY >= frameheight then
      begin
       frameheight := boxY + 1;
       expandflag := true;
      end;
     if expandflag = false then
      if boxbrace[boxX,boxY] = bbNone then boxbrace[boxX,boxY] := bbBrace
       else boxbrace[boxX,boxY] := bbNone;
    end;
  end;
 if button = mbright then
  begin
   if boxX <> $ff then
    begin
     code := 0;
     if (boxX < framewidth) and (boxY < frameheight) then code := 1;
     if boxX > 0 then  code := code or $2;
     if boxY > 0 then code := code or $4;
     case code of
      1 : begin
           framewidth := 1;
           frameheight := 1;
          end;
      3 : framewidth := boxX;
      5 : frameheight := boxY;
      7 : begin
           framewidth := boxX;
           frameheight := boxY;
          end;
     end;//case
     for j := 0 to 7 do
      for i := 0 to 7 do
       if (i >= framewidth) or (j >= frameheight) then
          boxbrace[i,j] := bbNone;
    end;
  end;//button mbRight
 paintframe;
end;

procedure TForm1.clearBtnClick(Sender: TObject);
begin
 menubutton := mbEdit;
 editBtn.Down := true;
 clearBraces;
 initcoords;
 paintframe;
 msglabel.Caption := '';
end;

procedure TForm1.editBtnClick(Sender: TObject);
//edit , test
begin
 case TEdit(sender).tag of
   1 : begin
        menubutton := mbEdit;
        msglabel.Caption := msg1;
        initcoords;
       end;
   2 : begin
        msglabel.Caption := '';
        menubutton := mbTest;
        testFrame;
       end;
 end;
 paintframe;
end;

procedure TForm1.storeBtnClick(Sender: TObject);
var f : file of TIOpack;
    i,m,n : byte;
    ch : char;
    OK : boolean;
begin
 for i := 1 to 16 do
  begin
   n := ((i-1) div 4) + 1;
   m := ((i-1) mod 4) shl 3;  //*8
   ch := fileID[i];
   IOpack[n] := IOpack[n] or (byte(ch) shl m);
  end;
  n := 5;
  IOpack[n] := framewidth or (frameheight shl 16);
  makeConnectionvectors;
  for i := 0 to 31 do
   begin
    inc(n);
    if i < 8 then IOpack[n] := rowvector[i] else IOpack[n] := 0;
   end;
//
  with savedialog1 do
   if execute then
    begin
     try
      OK := false;
      assignfile(f,filename);
      rewrite(f);
      write(f,IOpack);
      OK := true;
     finally
      closefile(f);
     end;
     if OK then msglabel.Caption := 'saved: '+filename
      else msglabel.Caption := 'cannot save';
    end;
end;

procedure TForm1.loadBtnClick(Sender: TObject);
var s : string;
    f : file of TIOpack;
    i,k,m,n : byte;
    OK,bb : boolean;
begin
 OK := false;
 s := '';
 with opendialog1 do
  if execute then
   begin
    try
     assignfile(f,filename);
     reset(f);
     read(f,IOpack);
     OK := true;
    finally
     closefile(f);
    end;
   if OK = false then msglabel.Caption := 'read failed'
    else
     begin
      for i := 1 to 16 do              //extract fileID
       begin
        n := ((i-1) div 4)+1;
        m := ((i-1) mod 4) shl 3;//*8
        s := s + chr(((IOpack[n] shr m) and $ff));
       end;
       if s <> fileID then msglabel.Caption := 'wrong format'
        else
         begin
          n := 5;
          framewidth := IOpack[n] and $ffff;
          frameheight := IOpack[n] shr 16;
          inc(n);
          for i := 0 to 31 do
           if i < 8 then
            for k := 0 to 7 do
             begin
              bb := ((1 shl k) and IOpack[n+i]) <> 0;
              if bb then boxbrace[k,i] := bbBrace;
             end;
         end;//else s <>
     end;//OK   
   end;
 if OK then
  begin
   menubutton := mbEdit;
   editBtn.Down := true;
   initcoords;
   msglabel.Caption := 'loaded: '+ opendialog1.FileName;
   paintframe;
  end;
end;

procedure TForm1.minBtnClick(Sender: TObject);
//remove extra braces, minimise frame
var i,j,n : byte;   //n: removed braces cont
begin
 n := 0;
 makeconnectionvectors;
 if rigidframe = false then msglabel.Caption := msg2
  else
   begin
    i := 0; j := 0;
    repeat
     if boxbrace[i,j] = bbBrace then
      begin
       boxbrace[i,j] := bbRemoved;
       makeconnectionvectors;
       if rigidframe then inc(n) else boxbrace[i,j] := bbBrace;
      end;
     inc(i);
     if i = framewidth then
      begin
       i := 0;
       inc(j);
      end;
    until j = frameheight;
    paintframe;
    msglabel.Caption := 'minimal frame, removed '+inttostr(n)+' braces';
   end;
end;

procedure TForm1.minclearBtnClick(Sender: TObject);
//remove grey braces
var i,j : byte;
begin
 for j := 0 to 7 do
  for i := 0 to 7 do
   if boxBrace[i,j] = bbRemoved then boxBrace[i,j] := bbNone;
 paintframe;
end;

procedure TForm1.helpbuttonClick(Sender: TObject);
begin
 ShellExecute(0,'open','http://www.davdata.nl/math/framework.html#help', nil, nil, SW_SHOWNORMAL);
end;

end.
